Index: EcnlProtoTool/trunk/asp3_dcre/kernel/mempfix.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/mempfix.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/mempfix.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -226,5 +226,5 @@
 	p_mpfmb = pk_cmpf->mpfmb;
 
-	CHECK_RSATR(mpfatr, TA_TPRI);
+	CHECK_VALIDATR(mpfatr, TA_TPRI);
 	CHECK_PAR(blkcnt != 0);
 	CHECK_PAR(blksz != 0);
@@ -242,5 +242,5 @@
 	else {
 		if (mpf == NULL) {
-			mpf = kernel_malloc(ROUND_MPF_T(blksz) * blkcnt);
+			mpf = malloc_mpk(ROUND_MPF_T(blksz) * blkcnt);
 			mpfatr |= TA_MEMALLOC;
 		}
@@ -250,10 +250,10 @@
 		else {
 			if (p_mpfmb == NULL) {
-				p_mpfmb = kernel_malloc(sizeof(MPFMB) * blkcnt);
+				p_mpfmb = malloc_mpk(sizeof(MPFMB) * blkcnt);
 				mpfatr |= TA_MBALLOC;
 			}
 			if (p_mpfmb == NULL) {
-				if (mpf == NULL) {
-					kernel_free(mpf);
+				if (pk_cmpf->mpf == NULL) {
+					free_mpk(mpf);
 				}
 				ercd = E_NOMEM;
@@ -313,8 +313,8 @@
 		p_mpfinib = (MPFINIB *)(p_mpfcb->p_mpfinib);
 		if ((p_mpfinib->mpfatr & TA_MEMALLOC) != 0U) {
-			kernel_free(p_mpfinib->mpf);
+			free_mpk(p_mpfinib->mpf);
 		}
 		if ((p_mpfinib->mpfatr & TA_MBALLOC) != 0U) {
-			kernel_free(p_mpfinib->p_mpfmb);
+			free_mpk(p_mpfinib->p_mpfmb);
 		}
 		p_mpfinib->mpfatr = TA_NOEXS;
@@ -342,7 +342,7 @@
 get_mpf(ID mpfid, void **p_blk)
 {
-	MPFCB	*p_mpfcb;
-	WINFO_MPF winfo_mpf;
-	ER		ercd;
+	MPFCB		*p_mpfcb;
+	WINFO_MPF	winfo_mpf;
+	ER			ercd;
 
 	LOG_GET_MPF_ENTER(mpfid, p_blk);
@@ -363,6 +363,6 @@
 	}
 	else {
-		p_runtsk->tstat = TS_WAITING_MPF;
-		wobj_make_wait((WOBJCB *) p_mpfcb, (WINFO_WOBJ *) &winfo_mpf);
+		wobj_make_wait((WOBJCB *) p_mpfcb, TS_WAITING_MPF,
+											(WINFO_WOBJ *) &winfo_mpf);
 		dispatch();
 		ercd = winfo_mpf.winfo.wercd;
@@ -424,8 +424,8 @@
 tget_mpf(ID mpfid, void **p_blk, TMO tmout)
 {
-	MPFCB	*p_mpfcb;
-	WINFO_MPF winfo_mpf;
-	TMEVTB	tmevtb;
-	ER		ercd;
+	MPFCB		*p_mpfcb;
+	WINFO_MPF	winfo_mpf;
+	TMEVTB		tmevtb;
+	ER			ercd;
 
 	LOG_TGET_MPF_ENTER(mpfid, p_blk, tmout);
@@ -450,7 +450,6 @@
 	}
 	else {
-		p_runtsk->tstat = TS_WAITING_MPF;
-		wobj_make_wait_tmout((WOBJCB *) p_mpfcb, (WINFO_WOBJ *) &winfo_mpf,
-														&tmevtb, tmout);
+		wobj_make_wait_tmout((WOBJCB *) p_mpfcb, TS_WAITING_MPF,
+								(WINFO_WOBJ *) &winfo_mpf, &tmevtb, tmout);
 		dispatch();
 		ercd = winfo_mpf.winfo.wercd;
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/mempfix.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/mempfix.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/mempfix.trb	(revision 429)
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -55,5 +55,5 @@
     params[:mpfmb] ||= "NULL"
 
-    # mpfatrが無効の場合（E_RSATR）［NGKI2225］
+    # mpfatrが無効の場合（E_RSATR）［NGKI2225］［NGKI2218］
     #（TA_TPRI以外のビットがセットされている場合）
     if (params[:mpfatr] & ~($TA_TPRI)) != 0
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/mutex.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/mutex.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/mutex.c	(revision 429)
@@ -4,5 +4,5 @@
  *      Advanced Standard Profile Kernel
  * 
- *  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -378,5 +378,5 @@
 	}
 	else {
-		CHECK_RSATR(mtxatr, TA_TPRI);			/*［NGKI2025］*/
+		CHECK_VALIDATR(mtxatr, TA_TPRI);		/*［NGKI2025］*/
 	}
 
@@ -473,7 +473,7 @@
 loc_mtx(ID mtxid)
 {
-	MTXCB	*p_mtxcb;
-	WINFO_MTX winfo_mtx;
-	ER		ercd;
+	MTXCB		*p_mtxcb;
+	WINFO_MTX	winfo_mtx;
+	ER			ercd;
 
 	LOG_LOC_MTX_ENTER(mtxid);
@@ -506,6 +506,6 @@
 	}
 	else {
-		p_runtsk->tstat = TS_WAITING_MTX;
-		wobj_make_wait((WOBJCB *) p_mtxcb, (WINFO_WOBJ *) &winfo_mtx);
+		wobj_make_wait((WOBJCB *) p_mtxcb, TS_WAITING_MTX,
+											(WINFO_WOBJ *) &winfo_mtx);
 		dispatch();
 		ercd = winfo_mtx.winfo.wercd;
@@ -576,8 +576,8 @@
 tloc_mtx(ID mtxid, TMO tmout)
 {
-	MTXCB	*p_mtxcb;
-	WINFO_MTX winfo_mtx;
-	TMEVTB	tmevtb;
-	ER		ercd;
+	MTXCB		*p_mtxcb;
+	WINFO_MTX	winfo_mtx;
+	TMEVTB		tmevtb;
+	ER			ercd;
 
 	LOG_TLOC_MTX_ENTER(mtxid, tmout);
@@ -614,7 +614,6 @@
 	}
 	else {
-		p_runtsk->tstat = TS_WAITING_MTX;
-		wobj_make_wait_tmout((WOBJCB *) p_mtxcb, (WINFO_WOBJ *) &winfo_mtx,
-														&tmevtb, tmout);
+		wobj_make_wait_tmout((WOBJCB *) p_mtxcb, TS_WAITING_MTX,
+								(WINFO_WOBJ *) &winfo_mtx, &tmevtb, tmout);
 		dispatch();
 		ercd = winfo_mtx.winfo.wercd;
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/mutex.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/mutex.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/mutex.trb	(revision 429)
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -51,6 +51,6 @@
 
   def prepare(key, params)
-    # mtxatrが無効の場合（E_RSATR）［NGKI2025］
-    # （TA_NULL，TA_TPRI，TA_CEILINGのいずれでもない場合）
+    # mtxatrが無効の場合（E_RSATR）［NGKI2025］［NGKI2010］
+    #（TA_NULL，TA_TPRI，TA_CEILINGのいずれでもない場合）
     if !(params[:mtxatr] == $TA_NULL || params[:mtxatr] == $TA_TPRI \
 										|| params[:mtxatr] == $TA_CEILING)
@@ -60,10 +60,10 @@
     if params[:mtxatr] == $TA_CEILING
       # 優先度上限ミューテックスの場合
-      # ceilpriが未指定の場合はエラーとする
-      if params[:ceilpri].nil?
+      # ceilpriの記述が省略されている場合［NGKI2035］
+      if !params.has_key?(:ceilpri)
         error_api(params, "ceilpri must be specified in %apiname of %mtxid")
 
-      # (TMIN_TPRI <= ceilpri && ceilpri <= TMAX_TPRI)でない場合（E_PAR）
-      # ［NGKI2037］
+      # ceilpriが有効範囲外の場合（E_PAR）［NGKI2037］
+      #（TMIN_TPRI <= ceilpri && ceilpri <= TMAX_TPRIでない場合）
       elsif !($TMIN_TPRI <= params[:ceilpri] && params[:ceilpri] <= $TMAX_TPRI)
         error_illegal_id("E_PAR", params, :ceilpri, :mtxid)
@@ -71,6 +71,6 @@
     else
       # 優先度上限ミューテックスでない場合
-      # ceilpriが指定されている場合は警告メッセージを出す
-      if !params[:ceilpri].nil?
+      # ceilpriが記述されている場合は警告メッセージを出す
+      if params.has_key?(:ceilpri)
         warning_api(params, "%%ceilpri is ignored in %apiname of %mtxid")
       end
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/pridataq.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/pridataq.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/pridataq.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -335,6 +335,9 @@
 	p_pdqmb = pk_cpdq->pdqmb;
 
-	CHECK_RSATR(pdqatr, TA_TPRI);
+	CHECK_VALIDATR(pdqatr, TA_TPRI);
 	CHECK_PAR(VALID_DPRI(maxdpri));
+	if (p_pdqmb != NULL) {
+		CHECK_PAR(MB_ALIGN(p_pdqmb));
+	}
 
 	lock_cpu();
@@ -344,5 +347,5 @@
 	else {
 		if (pdqcnt != 0 && p_pdqmb == NULL) {
-			p_pdqmb = kernel_malloc(sizeof(PDQMB) * pdqcnt);
+			p_pdqmb = malloc_mpk(sizeof(PDQMB) * pdqcnt);
 			pdqatr |= TA_MBALLOC;
 		}
@@ -405,5 +408,5 @@
 		p_pdqinib = (PDQINIB *)(p_pdqcb->p_pdqinib);
 		if ((p_pdqinib->pdqatr & TA_MBALLOC) != 0U) {
-			kernel_free(p_pdqinib->p_pdqmb);
+			free_mpk(p_pdqinib->p_pdqmb);
 		}
 		p_pdqinib->pdqatr = TA_NOEXS;
@@ -431,7 +434,7 @@
 snd_pdq(ID pdqid, intptr_t data, PRI datapri)
 {
-	PDQCB	*p_pdqcb;
-	WINFO_SPDQ winfo_spdq;
-	ER		ercd;
+	PDQCB		*p_pdqcb;
+	WINFO_SPDQ	winfo_spdq;
+	ER			ercd;
 
 	LOG_SND_PDQ_ENTER(pdqid, data, datapri);
@@ -460,6 +463,6 @@
 		winfo_spdq.data = data;
 		winfo_spdq.datapri = datapri;
-		p_runtsk->tstat = TS_WAITING_SPDQ;
-		wobj_make_wait((WOBJCB *) p_pdqcb, (WINFO_WOBJ *) &winfo_spdq);
+		wobj_make_wait((WOBJCB *) p_pdqcb, TS_WAITING_SPDQ,
+											(WINFO_WOBJ *) &winfo_spdq);
 		dispatch();
 		ercd = winfo_spdq.winfo.wercd;
@@ -504,5 +507,5 @@
 			}
 			else {
-				request_dispatch();
+				request_dispatch_retint();
 			}
 		}
@@ -529,8 +532,8 @@
 tsnd_pdq(ID pdqid, intptr_t data, PRI datapri, TMO tmout)
 {
-	PDQCB	*p_pdqcb;
-	WINFO_SPDQ winfo_spdq;
-	TMEVTB	tmevtb;
-	ER		ercd;
+	PDQCB		*p_pdqcb;
+	WINFO_SPDQ	winfo_spdq;
+	TMEVTB		tmevtb;
+	ER			ercd;
 
 	LOG_TSND_PDQ_ENTER(pdqid, data, datapri, tmout);
@@ -563,7 +566,6 @@
 		winfo_spdq.data = data;
 		winfo_spdq.datapri = datapri;
-		p_runtsk->tstat = TS_WAITING_SPDQ;
-		wobj_make_wait_tmout((WOBJCB *) p_pdqcb, (WINFO_WOBJ *) &winfo_spdq,
-														&tmevtb, tmout);
+		wobj_make_wait_tmout((WOBJCB *) p_pdqcb, TS_WAITING_SPDQ,
+								(WINFO_WOBJ *) &winfo_spdq, &tmevtb, tmout);
 		dispatch();
 		ercd = winfo_spdq.winfo.wercd;
@@ -586,7 +588,7 @@
 rcv_pdq(ID pdqid, intptr_t *p_data, PRI *p_datapri)
 {
-	PDQCB	*p_pdqcb;
-	WINFO_RPDQ winfo_rpdq;
-	ER		ercd;
+	PDQCB		*p_pdqcb;
+	WINFO_RPDQ	winfo_rpdq;
+	ER			ercd;
 
 	LOG_RCV_PDQ_ENTER(pdqid, p_data, p_datapri);
@@ -609,6 +611,5 @@
 	}
 	else {
-		p_runtsk->tstat = TS_WAITING_RPDQ;
-		make_wait(&(winfo_rpdq.winfo));
+		make_wait(TS_WAITING_RPDQ, &(winfo_rpdq.winfo));
 		queue_insert_prev(&(p_pdqcb->rwait_queue), &(p_runtsk->task_queue));
 		winfo_rpdq.p_pdqcb = p_pdqcb;
@@ -676,8 +677,8 @@
 trcv_pdq(ID pdqid, intptr_t *p_data, PRI *p_datapri, TMO tmout)
 {
-	PDQCB	*p_pdqcb;
-	WINFO_RPDQ winfo_rpdq;
-	TMEVTB	tmevtb;
-	ER		ercd;
+	PDQCB		*p_pdqcb;
+	WINFO_RPDQ	winfo_rpdq;
+	TMEVTB		tmevtb;
+	ER			ercd;
 
 	LOG_TRCV_PDQ_ENTER(pdqid, p_data, p_datapri, tmout);
@@ -704,6 +705,5 @@
 	}
 	else {
-		p_runtsk->tstat = TS_WAITING_RPDQ;
-		make_wait_tmout(&(winfo_rpdq.winfo), &tmevtb, tmout);
+		make_wait_tmout(TS_WAITING_RPDQ, &(winfo_rpdq.winfo), &tmevtb, tmout);
 		queue_insert_prev(&(p_pdqcb->rwait_queue), &(p_runtsk->task_queue));
 		winfo_rpdq.p_pdqcb = p_pdqcb;
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/pridataq.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/pridataq.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/pridataq.trb	(revision 429)
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -54,5 +54,5 @@
     params[:pdqmb] ||= "NULL"
 
-    # pdqatrが無効の場合（E_RSATR）［NGKI1804］
+    # pdqatrが無効の場合（E_RSATR）［NGKI1804］［NGKI1795］
     #（TA_TPRI以外のビットがセットされている場合）
     if (params[:pdqatr] & ~($TA_TPRI)) != 0
@@ -60,6 +60,6 @@
     end
 
-    # (TMIN_DPRI <= maxdpri && maxdpri <= TMAX_DPRI)でない場合（E_PAR）
-    # ［NGKI1819］
+	# maxdpriが有効範囲外の場合（E_PAR）［NGKI1819］
+    #（TMIN_DPRI <= maxdpri && maxdpri <= TMAX_DPRIでない場合）
     if !($TMIN_DPRI <= params[:maxdpri] && params[:maxdpri] <= $TMAX_DPRI)
       error_illegal_id("E_PAR", params, :maxdpri, :pdqid)
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/semaphore.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/semaphore.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/semaphore.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -186,5 +186,5 @@
 	maxsem = pk_csem->maxsem;
 
-	CHECK_RSATR(sematr, TA_TPRI);
+	CHECK_VALIDATR(sematr, TA_TPRI);
 	CHECK_PAR(0 <= isemcnt && isemcnt <= maxsem);
 	CHECK_PAR(1 <= maxsem && maxsem <= TMAX_MAXSEM);
@@ -286,5 +286,5 @@
 			}
 			else {
-				request_dispatch();
+				request_dispatch_retint();
 			}
 		}
@@ -315,7 +315,7 @@
 wai_sem(ID semid)
 {
-	SEMCB	*p_semcb;
-	WINFO_SEM winfo_sem;
-	ER		ercd;
+	SEMCB		*p_semcb;
+	WINFO_SEM	winfo_sem;
+	ER			ercd;
 
 	LOG_WAI_SEM_ENTER(semid);
@@ -336,6 +336,6 @@
 	}
 	else {
-		p_runtsk->tstat = TS_WAITING_SEM;
-		wobj_make_wait((WOBJCB *) p_semcb, (WINFO_WOBJ *) &winfo_sem);
+		wobj_make_wait((WOBJCB *) p_semcb, TS_WAITING_SEM,
+				 							(WINFO_WOBJ *) &winfo_sem);
 		dispatch();
 		ercd = winfo_sem.winfo.wercd;
@@ -394,8 +394,8 @@
 twai_sem(ID semid, TMO tmout)
 {
-	SEMCB	*p_semcb;
-	WINFO_SEM winfo_sem;
-	TMEVTB	tmevtb;
-	ER		ercd;
+	SEMCB		*p_semcb;
+	WINFO_SEM	winfo_sem;
+	TMEVTB		tmevtb;
+	ER			ercd;
 
 	LOG_TWAI_SEM_ENTER(semid, tmout);
@@ -420,7 +420,6 @@
 	}
 	else {
-		p_runtsk->tstat = TS_WAITING_SEM;
-		wobj_make_wait_tmout((WOBJCB *) p_semcb, (WINFO_WOBJ *) &winfo_sem,
-														&tmevtb, tmout);
+		wobj_make_wait_tmout((WOBJCB *) p_semcb, TS_WAITING_SEM,
+								(WINFO_WOBJ *) &winfo_sem, &tmevtb, tmout);
 		dispatch();
 		ercd = winfo_sem.winfo.wercd;
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/semaphore.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/semaphore.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/semaphore.trb	(revision 429)
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -51,5 +51,5 @@
 
   def prepare(key, params)
-    # sematrが無効の場合（E_RSATR）［NGKI1456］
+    # sematrが無効の場合（E_RSATR）［NGKI1456］［NGKI1448］
     #（TA_TPRI以外のビットがセットされている場合）
     if (params[:sematr] & ~($TA_TPRI)) != 0
@@ -57,10 +57,12 @@
     end
 
-    # (1 <= maxsem && maxsem <= TMAX_MAXSEM)でない場合（E_PAR）［NGKI1468］
+    # maxsemが有効範囲外の場合（E_PAR）［NGKI1468］
+    #（1 <= maxsem && maxsem <= TMAX_MAXSEMでない場合）
     if !(1 <= params[:maxsem] && params[:maxsem] <= $TMAX_MAXSEM)
       error_illegal_id("E_PAR", params, :maxsem, :semid)
     end
 
-    # (0 <= isemcnt && isemcnt <= maxsem)でない場合（E_PAR）［NGKI1466］
+    # isemcntが有効範囲外の場合（E_PAR）［NGKI1466］
+    #（0 <= isemcnt && isemcnt <= maxsemでない場合）
     if !(0 <= params[:isemcnt] && params[:isemcnt] <= params[:maxsem])
       error_wrong_id("E_PAR", params, :isemcnt, :semid, "too large")
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/startup.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/startup.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/startup.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -79,4 +79,9 @@
 
 /*
+ *  カーネルメモリプール領域有効フラグ
+ */
+bool_t	mpk_valid;
+
+/*
  *  カーネルの起動
  */
@@ -84,4 +89,6 @@
 sta_ker(void)
 {
+	uint_t	i;
+
 	/*
 	 *  TECSの初期化
@@ -102,5 +109,10 @@
 	 *  する必要がある．
 	 */
-	initialize_kmm();
+	if (mpk != NULL) {
+		mpk_valid = initialize_mempool(mpk, mpksz);
+	}
+	else {
+		mpk_valid = false;
+	}
 	initialize_tmevt();								/*［ASPD1061］*/
 	initialize_object();
@@ -109,5 +121,7 @@
 	 *  初期化ルーチンの実行
 	 */ 
-	call_inirtn();
+	for (i = 0; i < tnum_inirtn; i++) {
+		(*(inirtnb_table[i].inirtn))(inirtnb_table[i].exinf);
+	}
 
 	/*
@@ -172,8 +186,12 @@
 exit_kernel(void)
 {
+	uint_t	i;
+
 	/*
 	 *  終了処理ルーチンの実行
 	 */
-	call_terrtn();
+	for (i = 0; i < tnum_terrtn; i++) {
+		(*(terrtnb_table[i].terrtn))(terrtnb_table[i].exinf);
+	}
 
 	/*
@@ -187,26 +205,46 @@
 
 /*
- *  カーネルの割り付けるメモリ領域の管理
+ *  デフォルトのメモリプール管理機能
  *
- *  メモリ領域を先頭から順に割り当て，解放されたメモリ領域を再利用しな
- *  いメモリ管理モジュール．
+ *  メモリプール領域の先頭から順に割り当てを行い，すべてのメモリ領域が
+ *  解放されるまで解放されたメモリ領域を再利用しないメモリプール管理機
+ *  能．
  */
 #ifdef TOPPERS_kermem
-#ifndef OMIT_KMM_ALLOCONLY
-
-static void	*kmm_brk;
-
-void
-initialize_kmm(void)
-{
-	kmm_brk = ((char *) kmm) + kmmsz;
+#ifndef OMIT_MEMPOOL_DEFAULT
+
+typedef struct {
+	void	*brk;		/* メモリプール領域の未使用領域の先頭番地 */
+	void	*limit;		/* メモリプール領域の上限 */
+	uint_t	count;		/* 割り当てたメモリ領域の数 */
+} MEMPOOLCB;
+
+bool_t
+initialize_mempool(MB_T *mempool, size_t size)
+{
+	MEMPOOLCB	*p_mempoolcb = ((MEMPOOLCB *) mempool);
+
+	if (size >= sizeof(MEMPOOLCB)) {
+		p_mempoolcb->brk = ((char *) mempool) + sizeof(MEMPOOLCB);
+		p_mempoolcb->limit = ((char *) mempool) + size;
+		p_mempoolcb->count = 0;
+		return(true);
+	}
+	else {
+		return(false);
+	}
 }
 
 void *
-kernel_malloc(size_t size)
-{
-	if (((char *) kmm_brk) - ((char *) kmm) >= size) {
-		kmm_brk = ((char *) kmm_brk) - size;
-		return(kmm_brk);
+malloc_mempool(MB_T *mempool, size_t size)
+{
+	MEMPOOLCB	*p_mempoolcb = ((MEMPOOLCB *) mempool);
+	void		*brk;
+
+	brk = ((MEMPOOLCB *) mempool)->brk;
+	if (((char *)(p_mempoolcb->limit)) - ((char *) brk) >= size) {
+		p_mempoolcb->brk = ((char *) brk) + size;
+		p_mempoolcb->count += 1;
+		return(brk);
 	}
 	else {
@@ -216,8 +254,14 @@
 
 void
-kernel_free(void *ptr)
-{
-}
-
-#endif /* OMIT_KMM_ALLOCONLY */
+free_mempool(MB_T *mempool, void *ptr)
+{
+	MEMPOOLCB	*p_mempoolcb = ((MEMPOOLCB *) mempool);
+
+	p_mempoolcb->count -= 1;
+	if (p_mempoolcb->count == 0) {
+		p_mempoolcb->brk = ((char *) mempool) + sizeof(MEMPOOLCB);
+	}
+}
+
+#endif /* OMIT_MEMPOOL_DEFAULT */
 #endif /* TOPPERS_kermem */
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/sys_manage.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/sys_manage.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/sys_manage.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -184,5 +184,5 @@
 		}
 		else {
-			request_dispatch();
+			request_dispatch_retint();
 		}
 	}
@@ -205,13 +205,17 @@
 get_tid(ID *p_tskid)
 {
+	bool_t lock;
 	ER		ercd;
 
 	LOG_GET_TID_ENTER(p_tskid);
-	CHECK_UNL();								/*［NGKI2707］*/
-
-	lock_cpu();
+	//CHECK_UNL();								/*［NGKI2707］*/
+	lock = sense_lock();
+
+	if (!lock)
+		lock_cpu();
 	*p_tskid = (p_runtsk == NULL) ? TSK_NONE : TSKID(p_runtsk);
-	ercd = E_OK;
-	unlock_cpu();
+	ercd = E_OK;								/*［NGKI2710］［NGKI2709］*/
+	if (!lock)
+		unlock_cpu();
 
   error_exit:
@@ -399,6 +403,5 @@
 	enadsp = true;
 	if (t_get_ipm() == TIPM_ENAALL) {
-		dspflg = true;
-		p_schedtsk = search_schedtsk();
+		set_dspflg();
 		if (p_runtsk->raster && p_runtsk->enater) {
 			task_terminate(p_runtsk);
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/task.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/task.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/task.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2014 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2017 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -113,4 +113,5 @@
 		p_tcb->actque = false;
 		make_dormant(p_tcb);
+		p_tcb->p_lastmtx = NULL;
 		if ((p_tcb->p_tinib->tskatr & TA_ACT) != 0U) {
 			make_active(p_tcb);
@@ -232,5 +233,6 @@
  *
  *  実行すべきタスクを更新するのは，実行できるタスクがなかった場合と，
- *  p_tcbの優先度が実行すべきタスクの優先度よりも高い場合である．
+ *  p_tcbで指定されるタスクの優先度が実行すべきタスクの優先度よりも高
+ *  い場合である．
  */
 #ifdef TOPPERS_tskrun
@@ -256,8 +258,13 @@
  *  実行できる状態から他の状態への遷移
  *
- *  実行すべきタスクを更新するのは，p_tcbが実行すべきタスクであった場合
- *  である．p_tcbと同じ優先度のタスクが他にある場合は，p_tcbの次のタス
- *  クが実行すべきタスクになる．そうでない場合は，レディキューをサーチ
- *  する必要がある．
+ *  実行すべきタスクを更新するのは，p_tcbで指定されるタスクが実行すべ
+ *  きタスクであった場合である．p_tcbで指定されるタスクと同じ優先度の
+ *  タスクが他にある場合は，そのタスクの次のタスクが実行すべきタスクに
+ *  なる．そうでない場合は，レディキューをサーチする必要がある．
+ *
+ *  自タスクに対してこの関数が呼ばれるのは，タスクディスパッチ可能状態
+ *  に限られる．またこの関数は，非タスクコンテキストから呼ばれることは
+ *  ないため，p_runtskとp_schedtskは必ず一致している．そのため，p_tcb
+ *  とp_schedtskが一致するときは，必ずタスクディスパッチ可能状態である．
  */
 #ifdef TOPPERS_tsknrun
@@ -325,12 +332,14 @@
  *  タスクの優先度の変更
  *
- *  タスクが実行できる状態の場合には，レディキューの中での位置を変更す
- *  る．オブジェクトの待ちキューの中で待ち状態になっている場合には，待
- *  ちキューの中での位置を変更する．
- *
- *  実行すべきタスクを更新するのは，(1) p_tcbが実行すべきタスクであって，
- *  その優先度を下げた場合，(2) p_tcbが実行すべきタスクではなく，変更後
- *  の優先度が実行すべきタスクの優先度よりも高い場合である．(1)の場合に
- *  は，レディキューをサーチする必要がある．
+ *  p_tcbで指定されるタスクが実行できる状態の場合には，レディキューの
+ *  中での位置を変更する．オブジェクトの待ちキューの中で待ち状態になっ
+ *  ている場合には，待ちキューの中での位置を変更する．
+ *
+ *  実行すべきタスクを更新するのは，(1) p_tcbで指定されるタスクが実行
+ *  すべきタスクであった場合には，優先度を下げた（または優先度が変わら
+ *  なかった）時，(2) p_tcbで指定されるタスクが実行すべきタスクでなかっ
+ *  た場合には，変更後の優先度が実行すべきタスクの優先度よりも高いか同
+ *  じ時（同じ場合に更新が必要になるのは，実際には，mtxmodeがtrueの場
+ *  合のみ）である．(1)の場合には，レディキューをサーチする必要がある．
  */
 #ifdef TOPPERS_tskpri
@@ -367,7 +376,6 @@
 			}
 			else {
-				if (mtxmode ? newpri <= p_schedtsk->priority
-							: newpri < p_schedtsk->priority) {
-					p_schedtsk = p_tcb;
+				if (newpri <= p_schedtsk->priority) {
+					p_schedtsk = (TCB *)(ready_queue[newpri].p_next);
 				}
 			}
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/task.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/task.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/task.h	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2017 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -186,7 +186,4 @@
  *  が，実行効率が悪くなるために採用していない．他のオブジェクトについ
  *  ても同様に扱う．
- *
- *  タスク初期化ブロックには，DEF_TEXで定義されるタスク例外処理ルーチ
- *  ンに関する情報も含む．
  */
 typedef struct task_initialization_block {
@@ -239,5 +236,5 @@
 	BIT_FIELD_UINT	tstat : 8;		/* タスク状態（内部表現）*/
 	BIT_FIELD_UINT	bpriority : 8;	/* ベース優先度（内部表現）*/
-	BIT_FIELD_UINT	priority : 8	/* 現在の優先度（内部表現）*/;
+	BIT_FIELD_UINT	priority : 8;	/* 現在の優先度（内部表現）*/
 #endif /* UINT8_MAX */
 	BIT_FIELD_BOOL	actque : 1;		/* 起動要求キューイング */
@@ -380,7 +377,6 @@
  *  実行できる状態への遷移
  *
- *  p_tcbで指定されるタスクをレディキューに挿入する．レディキューに挿入
- *  したタスクの優先度が，実行すべきタスクの優先度よりも高い場合は，実
- *  行すべきタスクを更新する．
+ *  p_tcbで指定されるタスクをレディキューに挿入する．また，必要な場合
+ *  には，実行すべきタスクを更新する．
  */
 extern void	make_runnable(TCB *p_tcb);
@@ -396,4 +392,17 @@
 
 /*
+ *  タスクディスパッチ可能状態への遷移
+ *
+ *  タスクディスパッチ可能状態であることを示すフラグ（dspflg）をtrueに
+ *  し，実行すべきタスクを更新する．
+ */
+Inline void
+set_dspflg(void)
+{
+	dspflg = true;
+	p_schedtsk = search_schedtsk();
+}
+
+/*
  *  休止状態への遷移
  *
@@ -417,6 +426,7 @@
  *  必要な場合には，実行すべきタスクを更新する．
  *
- *  p_tcbで指定されるタスクの優先順位は，優先度が同じタスクの中で，
- *  mtxmodeがfalseの時は最低，mtxmodeがtrueの時は最高とする．
+ *  p_tcbで指定されるタスクが実行できる状態である場合，その優先順位は，
+ *  優先度が同じタスクの中で，mtxmodeがfalseの時は最低，mtxmodeがtrue
+ *  の時は最高とする．
  */
 extern void	change_priority(TCB *p_tcb, uint_t newpri, bool_t mtxmode);
@@ -425,6 +435,6 @@
  *  レディキューの回転
  *
- *  レディキュー中の，p_queueで指定されるタスクキューを回転させる．また，
- *  必要な場合には，実行すべきタスクを更新する．
+ *  レディキュー中の，p_queueで指定されるタスクキューを回転させる．ま
+ *  た，必要な場合には，実行すべきタスクを更新する．
  */
 extern void	rotate_ready_queue(QUEUE *p_queue);
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/task.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/task.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/task.trb	(revision 429)
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -54,5 +54,6 @@
     params[:stk] ||= "NULL"
 
-    # tskatrが無効の場合（E_RSATR）［NGKI1028］
+    # tskatrが無効の場合（E_RSATR）［NGKI1028］［NGKI3526］［ASPS0009］
+    # ［NGKI1016］
     #（TA_ACT，TA_NOACTQUE，TARGET_TSKATR以外のビットがセットされている場合）
     if (params[:tskatr] & ~($TA_ACT|$TA_NOACTQUE|$TARGET_TSKATR)) != 0
@@ -60,5 +61,6 @@
     end
 
-    # (TMIN_TPRI <= itskpri && itskpri <= TMAX_TPRI)でない場合［NGKI1034］
+    # itskpriが有効範囲外の場合（E_PAR）［NGKI1034］
+    #（TMIN_TPRI <= itskpri && itskpri <= TMAX_TPRIでない場合）
     if !($TMIN_TPRI <= params[:itskpri] && params[:itskpri] <= $TMAX_TPRI)
       error_illegal_id("E_PAR", params, :itskpri, :tskid)
@@ -66,5 +68,5 @@
 
     # stkszがターゲット定義の最小値（TARGET_MIN_STKSZ，未定義の場合は1）
-    # よりも小さい場合［NGKI1042］
+    # よりも小さい場合（E_PAR）［NGKI1042］
     if params[:stksz] < $TARGET_MIN_STKSZ
       error_wrong_id("E_PAR", params, :stksz, :tskid, "too small")
@@ -78,5 +80,5 @@
       params[:tinib_stk] = stkName
     else
-      # stkszがスタック領域のサイズとして正しくない場合［NGKI1056］
+      # stkszがターゲット定義の制約に合致しない場合（E_PAR）［NGKI1056］
       if (params[:stksz] & ($CHECK_STKSZ_ALIGN - 1)) != 0
         error_wrong_id("E_PAR", params, :stksz, :tskid, "not aligned")
@@ -85,4 +87,9 @@
       params[:tinib_stksz] = params[:stksz]
       params[:tinib_stk] = "(void *)(#{params[:stk]})"
+    end
+
+    # ターゲット依存の処理（ターゲット依存のエラーチェックを含む）
+    if defined? TargetTaskPrepare()
+      TargetTaskPrepare(key, params)
     end
   end
@@ -100,11 +107,13 @@
 end
 
+# タスクが1つも登録されていない場合［NGKI0033］
+if $cfgData[:CRE_TSK].size() == 0
+  error("no task is registered")
+end
+
 #
 #  タスク管理に関する情報の生成
 #
 $kernelCfgC.comment_header("Task Management Functions")
-if $cfgData[:CRE_TSK].size() == 0
-  error("no task is registered")
-end
 TaskObject.new.generate()
 
@@ -112,5 +121,5 @@
 $kernelCfgC.add("const ID _kernel_torder_table[TNUM_STSKID] = { ")
 $kernelCfgC.append("\t")
-$cfgData[:CRE_TSK].each_with_index do |(key, params), index|
+$cfgData[:CRE_TSK].each_with_index do |(_, params), index|
   $kernelCfgC.append(", ") if index > 0
   $kernelCfgC.append("#{params[:tskid]}")
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/task_manage.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/task_manage.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/task_manage.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2017 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -126,8 +126,4 @@
 #ifdef TOPPERS_acre_tsk
 
-#ifndef TARGET_MIN_STKSZ
-#define TARGET_MIN_STKSZ	1U		/* 未定義の場合は0でないことをチェック */
-#endif /* TARGET_MIN_STKSZ */
-
 ER_UINT
 acre_tsk(const T_CTSK *pk_ctsk)
@@ -151,5 +147,5 @@
 	stk = pk_ctsk->stk;
 
-	CHECK_RSATR(tskatr, TA_ACT|TA_NOACTQUE|TARGET_TSKATR);
+	CHECK_VALIDATR(tskatr, TA_ACT|TA_NOACTQUE|TARGET_TSKATR);
 	CHECK_PAR(FUNC_ALIGN(task));
 	CHECK_PAR(FUNC_NONNULL(task));
@@ -168,5 +164,5 @@
 		if (stk == NULL) {
 			stksz = ROUND_STK_T(stksz);
-			stk = kernel_malloc(stksz);
+			stk = malloc_mpk(stksz);
 			tskatr |= TA_MEMALLOC;
 		}
@@ -189,7 +185,11 @@
 
 			p_tcb->actque = false;
+			p_tcb->p_lastmtx = NULL;
 			make_dormant(p_tcb);
 			if ((p_tcb->p_tinib->tskatr & TA_ACT) != 0U) {
 				make_active(p_tcb);
+				if (p_runtsk != p_schedtsk) {
+					dispatch();
+				}
 			}
 			ercd = TSKID(p_tcb);
@@ -235,5 +235,5 @@
 #else /* USE_TSKINICTXB */
 		if ((p_tinib->tskatr & TA_MEMALLOC) != 0U) {	/*［NGKI1109］*/
-			kernel_free(p_tinib->stk);
+			free_mpk(p_tinib->stk);
 		}
 #endif /* USE_TSKINICTXB */
@@ -283,5 +283,5 @@
 			}
 			else {
-				request_dispatch();
+				request_dispatch_retint();
 			}
 		}
@@ -423,4 +423,9 @@
 	}
 	if (tskpri == TPRI_INI) {
+		/*
+		 *  以下の代入文は，対象タスクが未登録の場合に無効なフィールド
+		 *  を参照するが，その場合はnewbpriの値を使わないので，問題な
+		 *  い．
+		 */
 		newbpri = p_tcb->p_tinib->ipriority;	/*［NGKI1199］*/
 	}
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/task_refer.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/task_refer.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/task_refer.c	(revision 429)
@@ -4,5 +4,5 @@
  *      Advanced Standard Profile Kernel
  * 
- *  Copyright (C) 2005-2014 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -67,5 +67,5 @@
 
 /*
- *  タスクの状態参照
+ *  タスクの状態参照［NGKI1217］
  */
 #ifdef TOPPERS_ref_tsk
@@ -79,10 +79,10 @@
 
 	LOG_REF_TSK_ENTER(tskid, pk_rtsk);
-	CHECK_TSKCTX_UNL();
+	CHECK_TSKCTX_UNL();							/*［NGKI1218］［NGKI1219］*/
 	if (tskid == TSK_SELF) {
-		p_tcb = p_runtsk;
+		p_tcb = p_runtsk;						/*［NGKI1248］*/
 	}
 	else {
-		CHECK_ID(VALID_TSKID(tskid));
+		CHECK_ID(VALID_TSKID(tskid));			/*［NGKI1220］*/
 		p_tcb = get_tcb(tskid);
 	}
@@ -90,5 +90,5 @@
 	lock_cpu();
 	if (p_tcb->p_tinib->tskatr == TA_NOEXS) {
-		ercd = E_NOEXS;
+		ercd = E_NOEXS;							/*［NGKI1221］*/
 	}
 	else {
@@ -96,5 +96,5 @@
 		if (TSTAT_DORMANT(tstat)) {
 			/*
-	 		 *  対象タスクが休止状態の場合
+	 		 *  対象タスクが休止状態の場合［NGKI1225］
 			 */
 			pk_rtsk->tskstat = TTS_DMT;
@@ -102,5 +102,5 @@
 		else {
 			/*
-	 		 *  タスク状態の取出し
+	 		 *  タスク状態の取出し［NGKI1225］
 			 */
 			if (TSTAT_SUSPENDED(tstat)) {
@@ -123,5 +123,5 @@
 
 			/*
-	 		 *  現在優先度とベース優先度の取出し
+	 		 *  現在優先度とベース優先度の取出し［NGKI1227］
 			 */
 			pk_rtsk->tskpri = EXT_TSKPRI(p_tcb->priority);
@@ -130,7 +130,8 @@
 			if (TSTAT_WAITING(tstat)) {
 				/*
-		 		 *  待ち要因と待ち対象のオブジェクトのIDの取出し
+		 		 *  待ち要因と待ち対象のオブジェクトのIDの取出し［NGKI1229］
+				 *  ［NGKI1231］
 				 */
-				switch (tstat) {
+				switch (tstat & TS_WAITING_MASK) {
 				case TS_WAITING_SLP:
 					pk_rtsk->tskwait = TTW_SLP;
@@ -185,24 +186,24 @@
 				 */
 				if (p_tcb->p_winfo->p_tmevtb != NULL) {
-					pk_rtsk->lefttmo
+					pk_rtsk->lefttmo			/*［NGKI1233］［NGKI1235］*/
 							= (TMO) tmevt_lefttim(p_tcb->p_winfo->p_tmevtb);
 				}
 				else {
-					pk_rtsk->lefttmo = TMO_FEVR;
-				}
-			}
-
-			/*
-	 		 *  起床要求キューイング数の取出し
+					pk_rtsk->lefttmo = TMO_FEVR;	/*［NGKI1234］*/
+				}
+			}
+
+			/*
+	 		 *  起床要求キューイング数の取出し［NGKI1239］
 			 */
 			pk_rtsk->wupcnt = p_tcb->wupque ? 1U : 0U;
 
 			/*
-			 *  タスク終了要求状態の取出し
+			 *  タスク終了要求状態の取出し［NGKI3467］
 			 */
 			pk_rtsk->raster = p_tcb->raster;
 
 			/*
-			 *  タスク終了禁止状態の取出し
+			 *  タスク終了禁止状態の取出し［NGKI3468］
 			 */
 			pk_rtsk->dister = !(p_tcb->enater);
@@ -210,5 +211,5 @@
 
 		/*
-		 *  起動要求キューイング数の取出し
+		 *  起動要求キューイング数の取出し［NGKI1238］
 		 */
 		pk_rtsk->actcnt = p_tcb->actque ? 1U : 0U;
